  /* GFAhnen: Baum-Steuerung (ffnen/Schlieen von Baum-Knoten) Stand 30.07.2009 
   * hierzu ist stylesheet gfabaum.css erforderlich
   *
   */ 

  /* Fgt Listeneintrgen Eventhandler und CSS-Klassen hinzu.
   * Ordnet Listeneintrgen die Klasse Baum_opened zu.
   * 
   * menu: Referenz auf die Liste.
   * data: String, der die Nummern aufgeklappter Zweige enthlt.
   *
   * Beim erstmaligen Aufruf (feld = null) wird der Baum ganz geffnet,
   * bei weiteren Aufrufen nur die Zweige, die in feld genannt sind.
   */
  function Baum_init(menu, data) {
    gen = 1; gmax = 0;
    var Zustd = "Baum_opened";
    var feld = new Array(0);
    if (navigator.appName=="Netscape") { Zustd = "Baum_opened"; }
    if(data != null && data != "") { feld = data.match(/\d+/g); }
/* if (feld) { alert('Feld anf = '+feld.join(" ")); }       */
    var items = menu.getElementsByTagName("span");
    for(var i = 0; i < items.length; i++) {
      if ((items[i].className=='auf') || (items[i].className=='zu')) {
      items[i].onclick = Baum_handleClick;
      items[i].style.cursor = "pointer"; 
      }
     }
    var items = menu.getElementsByTagName("li");
    for(var i = 0; i < items.length; i++) {
      if (items[i].value > gmax) { gmax = items[i].value }
      var classes = Baum_getClasses(items[i]);
      classes.pop();
      if (feld!==null && feld.length>0) {
            if (feld[0]==i) { classes.push("Baum_opened"); feld.shift(); } 
                       else { classes.push("Baum_closed"); }                     
           } else { classes.push(Zustd); }
         items[i].className = classes.join(" ");
      }
   gen = gmax;
   var knopf = document.getElementById("KnopfBereich");
   knopf.style.display="inline";
   var klapt = document.getElementById("KlappText");
   klapt.style.display="inline";
   Baum_Call();
/* alert('Feld aktuell ='+Baum_store(document)); */
  }

  /*
   *
   *
   */
  function Baum_aufklappen(menu) {
    gen = gmax;
    var items = menu.getElementsByTagName("li");
    for(var i = 0; i < items.length; i++) {
      if(Baum_contains(Baum_getClasses(items[i]), "Baum_closed")) {
        var classes = Baum_getClasses(items[i]);
          classes.pop();
          classes.push("Baum_opened")
        items[i].className = classes.join(" ");
      }
    }
  }

  /*
   *
   *
   */
  function Baum_zuklappen(menu) {
    gen = 1;
    var items = menu.getElementsByTagName("li");
    for(var i = 0; i < items.length; i++) {
      if(Baum_contains(Baum_getClasses(items[i]), "Baum_opened")) {
        var classes = Baum_getClasses(items[i]);
          classes.pop();
          classes.push("Baum_closed")
        items[i].className = classes.join(" ");
      }
    }
  }

  /*
   *
   *
   */
  var   gen = 1;
  var   gmax = 25;

  function Baum_weiter(menu) {
    gen = gen + 1; if(gen > gmax) { gen = gmax }
    var items = menu.getElementsByTagName("li");
    for(var i = 0; i < items.length; i++) {
      if(Baum_contains(Baum_getClasses(items[i]), "Baum_closed")
        && (items[i].value < gen)) {
        var classes = Baum_getClasses(items[i]);
          classes.pop();
          classes.push("Baum_opened")
        items[i].className = classes.join(" ");
      }
    }
  }

  function Baum_zurueck(menu) {
    gen = gen - 1; if (gen < 1) { gen = 1 }
    var items = menu.getElementsByTagName("li");
    for(var i = 0; i < items.length; i++) {
      if(Baum_contains(Baum_getClasses(items[i]), "Baum_opened")
        && (items[i].value >= gen)) {
        var classes = Baum_getClasses(items[i]);
          classes.pop();
          classes.push("Baum_closed")
        items[i].className = classes.join(" ");
      }
    }

  }

  /*
   * ndert die Klasse eines angeclickten Listenelements, sodass
   * geffnete Listeelemente geschlossen und geschlossene geffnet
   * werden.
   *
   * event: Das Event-Objekt, das der Browser bergibt.
   */
  function Baum_handleClick(event) {
    if(event == null) { //Workaround fr die fehlenden DOM Eigenschaften im IE
      event = window.event;
      event.currentTarget = event.srcElement;
      while(event.currentTarget.nodeName.toLowerCase() != "li") {
        event.currentTarget = event.currentTarget.parentNode;
      }
      event.cancelBubble = true;
    }
    else {
      event.stopPropagation();
    }

     var ding = event.currentTarget;
     while(ding.nodeName.toLowerCase() != "li") {
        ding = ding.parentNode;
      }
    var feld = Baum_getClasses(ding);
    for(var i = 0; i < feld.length; i++) {
      if(feld[i] == "Baum_closed") {
        feld[i] = "Baum_opened";
      }
      else if(feld[i] == "Baum_opened") {
        feld[i] = "Baum_closed"
      }
    }
    ding.className = feld.join(" ");
  }
  
  /*
   * Gibt alle Klassen zurck, die einem HTML-Element zugeordnet sind.
   * 
   * element: Das HTML-Element
   * return: Die zugeordneten Klassen.
   */
  function Baum_getClasses(element) {
    if(element.className) {
      return element.className.match(/[^ \t\n\r]+/g);
    }
    else {
      return new Array(0);
    }
  }
  
  /*
   * berprft, ob ein Array ein bestimmtes Element enthlt.
   * 
   * feld: Das Array
   * element: Das Element
   * return: true, wenn das Array das Element enthlt.
   */
  function Baum_contains(feld, element) {
    for(var i = 0; i < feld.length; i++) {
      if(feld[i] == element) {
        return true;
      }
    }
    return false;
  }
  
  /*
   * Gibt einen String zurck, in dem die Nummern aller geffneten
   * Zweige stehen. 
   *
   * menu: Referenz auf die Liste
   * return: Der String
   */
  function Baum_store(menu) {
    var result = new Array();;
    var items = menu.getElementsByTagName("li");
    for(var i = 0; i < items.length; i++) {
      if(Baum_contains(Baum_getClasses(items[i]), "Baum_opened")) {
        result.push(i);
      }
    }
    return result.join(" ");
  }
  /*
   * Markiert document-internes Sprungziel 
   * 
   */
  function Baum_markiere(ziel) {
   Baum_killMarcs();
   var dinger=document.getElementsByName(ziel);
   if (dinger && dinger.length > 0) {
     var ding = dinger[0].parentNode;

     var classes = Baum_getClasses(ding);
     classes.push('marc');
     ding.className = classes.join(" ");
   }
  }
  /*
   * Markiert Sprungziel im Aufruf
   * 
   */
  function Baum_Call() {
   var Ref = location.href;
   var inx = Ref.lastIndexOf('#');
   if (inx > -1) {
   Ref = Ref.substring(inx+1,Ref.length);
   Baum_markiere(Ref);  
    }
  }
  /*
   * Lscht Markierungen
   * 
   */
  function Baum_killMarcs() {
   var items = document.getElementsByTagName("span");
    for(var i = 0; i < items.length; i++) {
      if (Baum_contains(Baum_getClasses(items[i]), "marc")) {
         var classes = Baum_getClasses(items[i]);
         classes.pop();
    items[i].className = classes.join(" ");
     }
   }
  }