SELECT /* Felder der Ergebnistabelle */
 SUBSTRING(a.Datum 
FROM 7 FOR 4) ||'.'|| SUBSTRING(a.Datum FROM 4 FOR 2) ||'.'|| 
SUBSTRING(a.Datum FROM 1 FOR 2) AS EheDat, a.A ||'\~'|| 
CAST(a.ENrM AS 
CHARACTER(1)) ||'/'|| CAST(a.ENrF AS CHARACTER(1)) AS Ehe, 
a.Ort, 
a.PNM, b.FName||', '||b.VName AS Mann, b.GebDat as GebM, 
a.PNF, c.FName||', '||c.VName AS Frau, c.GebDat as GebF 
FROM /* Tabellennamen */
 Ehen.db a 
 LEFT OUTER JOIN Ahnen.db b ON (a.PNM = b.PN) 
 LEFT OUTER JOIN Ahnen.db c ON (a.PNF = c.PN)
WHERE (a.ORT LIKE :Heiratsort)
ORDER BY /* Felder, nach denen das Ergebnis sortiert wird */
Ehedat
