SELECT /* Felder der Ergebnistabelle */
 a.PN, a.ActDate AS Datum, a.FName||', '||a.VName AS Name, 
a.GebDat, a.GebOrt, a.SterDat, a.SterOrt
FROM /* Tabellennamen */
 Ahnen.db a
WHERE /* Suchbedingungen */
 (a.ActDate >= CAST(:vonDatum as DATE)) AND (a.ActDate <= 
CAST(:bisDatum as DATE))
ORDER BY /* Felder, nach denen das Ergebnis sortiert wird */
 a.ActDate, Name
