SELECT  /* Felder der Ergebnistabelle */
a.PN, a.FName||', '||a.VName AS Name, a.GebDat, a.GebOrt, 
c.PN AS PNP, c.FName||', '||c.VName AS Pate, 
c.GebDat AS GDatP, c.GebOrt AS GOrtP
FROM Ahnen a, Verbund p, Ahnen c
WHERE (a.FName Like :FName) AND (a.PN=p.PN) AND (p.PNV=c.PN) AND 
(p.Art='PAT')
ORDER by Name, GebDat, Pate, GDatP
/* 'Gitteranpassung' aktivieren! */
