SELECT  /* Felder der Ergebnistabelle */
a.PN, a.FName||', '||a.VName AS Name, a.GebDat, a.GebOrt, 
c.PN AS PNPK, c.FName||', '||c.VName AS Patenkind, 
c.GebDat AS GDatPK, c.GebOrt AS GOrtPK
FROM Ahnen a, Verbund p, Ahnen c
WHERE (a.FName Like :FName) AND (a.PN=p.PNV) AND (p.PN=c.PN) AND 
(p.Art='PAT')
ORDER by Name, GebDat, Patenkind, GDatPK
/* 'Gitteranpassung' aktivieren! */
