SELECT /* Felder der Ergebnistabelle */
 a.Lebensph, SUBSTRING(a.vonDatum FROM 7 FOR 10) AS 
von, 
SUBSTRING(a.bisDatum FROM 7 FOR 10) AS bis, a.Ort ||' '|| 
a.Zusatz as Ort, 
b.PN, c.Kekule AS Kek, b.FName ||', '||b.VName as Name, 
b.GebDat, b.GebOrt
FROM /* Tabellennamen */
 LebPhasen.db a INNER JOIN Ahnen.db b
ON /* Suchbedingungen */ (a.PN=b.PN) AND (a.Art='WOH') 
      LEFT OUTER JOIN Kekule.db c ON (b.PN=c.PN)
ORDER BY /* Felder, nach denen das Ergebnis sortiert wird */
 Ort, Name, b.GebDat
